# -*- coding: UTF-8 -*-
from Products.Abschnitt.config import ARTICLE_GROUPS
#from Products.Archetypes.public import BaseSchema, Schema
#from Products.Archetypes.public import StringField, TextField
#from Products.Archetypes.public import SelectionWidget, TextAreaWidget
#from Products.Archetypes.public import RichWidget
#from Products.Archetypes.public import BaseContent, registerType

import string


try:
    from Products.LinguaPlone.public import *
except ImportError:
    # No multilingual support
    from Products.Archetypes.public import *
from Products.Archetypes.Marshall import PrimaryFieldMarshaller
from Products.CMFCore import CMFCorePermissions
from config import PROJECTNAME

mytext = 'Kurztext fr die Prsentation'
labeltext = mytext.decode('iso-8859-1').encode('utf-8')
schema = BaseSchema +  Schema((
    TextField('inhalt',
              searchable=1,
              required=1,
              primary=1,
              default_output_type='text/html',
              allowable_content_types=('text/plain','text/html'),
              widget=RichWidget(label='Inhalt'),
              ),
    TextField('zusammenfassung',
              searchable=1,
              required=0,
              default_output_type='text/html',
              allowable_content_types=('text/html'),
              widget=TextAreaWidget(label=labeltext),
              ),

    ),
                              marshall=PrimaryFieldMarshaller(),
                              )

class Abschnitt(BaseContent):
    """Der Abschnitt ist der Basisbaustein eines Referats."""
    meta_type = 'Abschnitt'
    archetype_name = 'Abschnitt'
    content_icon = 'abschnitt_icon.gif'
    schema = schema
    actions = ({
        'id': 'view',
        'name': 'View',
        'action': 'string:${object_url}/abschnitt_view',
        'permissions': (CMFCorePermissions.View,)
        },)

registerType(Abschnitt, PROJECTNAME)
